import { createRawSnippet } from "svelte";
import { renderToString } from "react-dom/server";
import { hydrateRoot } from "react-dom/client";
export const createSnippet = (fn) => {
    return createRawSnippet((...params) => {
        return {
            render: () => `<div style="display:contents">${renderToString(fn(...params))}</div>`,
            setup(element) {
                let firstEffect = true;
                const root = hydrateRoot(element, fn(...params));
                $effect(() => {
                    const node = fn(...params);
                    if (firstEffect)
                        firstEffect = false;
                    else
                        root.render(node);
                });
                return () => root.unmount();
            },
        };
    });
};
